diff -bruN freeswan-1.9.orig/pluto/spdb.c freeswan-1.9/pluto/spdb.c
--- freeswan-1.9.orig/pluto/spdb.c	Mon Feb 26 13:42:57 2001
+++ freeswan-1.9/pluto/spdb.c	Thu Jun  7 14:33:57 2001
@@ -11,7 +11,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: spdb.c,v 1.63.2.1 2001/02/26 18:42:57 henry Exp $
+ * RCSID $Id: spdb.c,v 1.69 2001/04/09 19:48:43 dhr Exp $
  */
 
 #include <stdio.h>
@@ -39,6 +39,11 @@
 #include "md5.h"
 #include "crypto.h" /* requires sha1.h and md5.h */
 
+#ifdef OPENSSL
+#include "demux.h"
+#include "openssl.h"
+#endif
+
 #define AD(x) x, elemsof(x)	/* Array Description */
 #define AD_NULL NULL, 0
 
@@ -46,6 +51,12 @@
 
 /* arrays of attributes for transforms, preshared key */
 
+static struct db_attr otpsk1024desmd5[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_PRESHARED_KEY },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
 static struct db_attr otpsk1024des3md5[] = {
 	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
 	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
@@ -53,6 +64,12 @@
 	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
 	};
 
+static struct db_attr otpsk1536desmd5[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_PRESHARED_KEY },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
 static struct db_attr otpsk1536des3md5[] = {
 	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
 	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
@@ -60,6 +77,12 @@
 	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
 	};
 
+static struct db_attr otpsk1024dessha[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_PRESHARED_KEY },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
 static struct db_attr otpsk1024des3sha[] = {
 	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
 	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
@@ -67,6 +90,12 @@
 	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
 	};
 
+static struct db_attr otpsk1536dessha[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_PRESHARED_KEY },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
 static struct db_attr otpsk1536des3sha[] = {
 	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
 	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
@@ -76,6 +105,12 @@
 
 /* arrays of attributes for transforms, RSA signatures */
 
+static struct db_attr otrsasig1024desmd5[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
 static struct db_attr otrsasig1024des3md5[] = {
 	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
 	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
@@ -83,6 +118,12 @@
 	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
 	};
 
+static struct db_attr otrsasig1536desmd5[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
 static struct db_attr otrsasig1536des3md5[] = {
 	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
 	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
@@ -90,6 +131,12 @@
 	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
 	};
 
+static struct db_attr otrsasig1024dessha[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
 static struct db_attr otrsasig1024des3sha[] = {
 	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
 	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
@@ -97,6 +144,12 @@
 	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
 	};
 
+static struct db_attr otrsasig1536dessha[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
 static struct db_attr otrsasig1536des3sha[] = {
 	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
 	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
@@ -104,11 +157,305 @@
 	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
 	};
 
+#ifdef OPENSSL /* OPENSSL */
+static struct db_attr ot1024desmd5_ds_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+static struct db_attr ot1024des3md5_ds_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024dessha_ds_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+static struct db_attr ot1024des3sha_ds_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024dessha_ds_dss[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_DSS_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+static struct db_attr ot1024des3sha_ds_dss[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_DSS_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024desmd5_pk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+static struct db_attr ot1024des3md5_pk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024dessha_pk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+static struct db_attr ot1024des3sha_pk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024dessha_pk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+static struct db_attr ot1024des3sha_pk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024desmd5_pk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+static struct db_attr ot1024des3md5_pk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024desmd5_rpk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+static struct db_attr ot1024des3md5_rpk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024dessha_rpk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+static struct db_attr ot1024des3sha_rpk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024dessha_rpk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+static struct db_attr ot1024des3sha_rpk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1024desmd5_rpk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+static struct db_attr ot1024des3md5_rpk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
+
+static struct db_attr ot1536desmd5_ds_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+static struct db_attr ot1536des3md5_ds_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+
+static struct db_attr ot1536dessha_ds_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+static struct db_attr ot1536des3sha_ds_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+
+static struct db_attr ot1536dessha_ds_dss[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_DSS_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+static struct db_attr ot1536des3sha_ds_dss[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_DSS_SIG },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+
+static struct db_attr ot1536desmd5_pk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+static struct db_attr ot1536des3md5_pk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+
+static struct db_attr ot1536dessha_pk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+static struct db_attr ot1536des3sha_pk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+
+static struct db_attr ot1536dessha_pk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+static struct db_attr ot1536des3sha_pk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+
+static struct db_attr ot1536desmd5_pk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+static struct db_attr ot1536des3md5_pk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+
+static struct db_attr ot1536desmd5_rpk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+static struct db_attr ot1536des3md5_rpk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+
+static struct db_attr ot1536dessha_rpk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+static struct db_attr ot1536des3sha_rpk_rsa[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_RSA_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+
+static struct db_attr ot1536dessha_rpk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+static struct db_attr ot1536des3sha_rpk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_SHA },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+
+static struct db_attr ot1536desmd5_rpk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+static struct db_attr ot1536des3md5_rpk_elgamal[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_MD5 },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_ELGAMAL_ENC_REV },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1536 },
+	};
+#endif /* OPENSSL */
+
 /* We won't accept this, but by proposing it, we get to test
  * our rejection.  We better not propose it to an IKE daemon
  * that will accept it!
  */
 #ifdef TEST_INDECENT_PROPOSAL
+static struct db_attr otpsk1024destiger[] = {
+	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_DES_CBC },
+	{ OAKLEY_HASH_ALGORITHM, OAKLEY_TIGER },
+	{ OAKLEY_AUTHENTICATION_METHOD, OAKLEY_PRESHARED_KEY },
+	{ OAKLEY_GROUP_DESCRIPTION, OAKLEY_GROUP_MODP1024 },
+	};
 static struct db_attr otpsk1024des3tiger[] = {
 	{ OAKLEY_ENCRYPTION_ALGORITHM, OAKLEY_3DES_CBC },
 	{ OAKLEY_HASH_ALGORITHM, OAKLEY_TIGER },
@@ -119,6 +466,7 @@
 
 /* tables of transforms, in preference order (select based on AUTH) */
 
+
 static struct db_trans oakley_trans_psk[] = {
 #ifdef TEST_INDECENT_PROPOSAL
 	{ KEY_IKE, AD(otpsk1024des3tiger) },
@@ -127,6 +475,14 @@
 	{ KEY_IKE, AD(otpsk1024des3md5) },
 	{ KEY_IKE, AD(otpsk1536des3md5) },
 	{ KEY_IKE, AD(otpsk1536des3sha) },
+/* DES */
+#ifdef TEST_INDECENT_PROPOSAL
+	{ KEY_IKE, AD(otpsk1024destiger) },
+#endif
+	{ KEY_IKE, AD(otpsk1024dessha) },
+	{ KEY_IKE, AD(otpsk1024desmd5) },
+	{ KEY_IKE, AD(otpsk1536desmd5) },
+	{ KEY_IKE, AD(otpsk1536dessha) },
     };
 
 static struct db_trans oakley_trans_rsasig[] = {
@@ -134,8 +490,139 @@
 	{ KEY_IKE, AD(otrsasig1024des3md5) },
 	{ KEY_IKE, AD(otrsasig1536des3md5) },
 	{ KEY_IKE, AD(otrsasig1536des3sha) },
+/* DES */
+	{ KEY_IKE, AD(otrsasig1024dessha) },
+	{ KEY_IKE, AD(otrsasig1024desmd5) },
+	{ KEY_IKE, AD(otrsasig1536desmd5) },
+	{ KEY_IKE, AD(otrsasig1536dessha) },
     };
 
+#ifdef OPENSSL
+static struct db_trans oakley_trans_psk2[] = {
+#ifdef TEST_INDECENT_PROPOSAL
+	{ KEY_IKE, AD(otpsk1024des3tiger), NULL },
+#endif
+	{ KEY_IKE, AD(otpsk1024des3sha), NULL },
+	{ KEY_IKE, AD(otpsk1024des3md5), NULL },
+	{ KEY_IKE, AD(otpsk1536des3md5), NULL },
+	{ KEY_IKE, AD(otpsk1536des3sha), NULL },
+/* DES */
+#ifdef TEST_INDECENT_PROPOSAL
+	{ KEY_IKE, AD(otpsk1024destiger), NULL },
+#endif
+	{ KEY_IKE, AD(otpsk1024dessha), NULL },
+	{ KEY_IKE, AD(otpsk1024desmd5), NULL },
+	{ KEY_IKE, AD(otpsk1536desmd5), NULL },
+	{ KEY_IKE, AD(otpsk1536dessha), NULL },
+    };
+
+static struct db_trans oakley_trans_openssl[] = {
+	{ KEY_IKE, AD(ot1024des3sha_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024des3sha_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024des3md5_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024des3md5_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024des3sha_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024des3sha_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024des3md5_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024des3md5_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024des3sha_ds_dss), have_dss_key },
+	{ KEY_IKE, AD(ot1024des3sha_ds_rsa), have_rsa_key },
+	{ KEY_IKE, AD(ot1024des3md5_ds_rsa), have_rsa_key },
+	{ KEY_IKE, AD(ot1536des3sha_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536des3sha_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536des3md5_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536des3md5_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536des3sha_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536des3sha_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536des3md5_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536des3md5_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536des3sha_ds_dss), have_dss_key },
+	{ KEY_IKE, AD(ot1536des3sha_ds_rsa), have_rsa_key },
+	{ KEY_IKE, AD(ot1536des3md5_ds_rsa), have_rsa_key },
+/* DES */
+	{ KEY_IKE, AD(ot1024dessha_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024dessha_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024desmd5_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024desmd5_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024dessha_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024dessha_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024desmd5_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024desmd5_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024dessha_ds_dss), have_dss_key },
+	{ KEY_IKE, AD(ot1024dessha_ds_rsa), have_rsa_key },
+	{ KEY_IKE, AD(ot1024desmd5_ds_rsa), have_rsa_key },
+	{ KEY_IKE, AD(ot1536dessha_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536dessha_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536desmd5_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536desmd5_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536dessha_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536dessha_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536desmd5_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536desmd5_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536dessha_ds_dss), have_dss_key },
+	{ KEY_IKE, AD(ot1536dessha_ds_rsa), have_rsa_key },
+	{ KEY_IKE, AD(ot1536desmd5_ds_rsa), have_rsa_key },
+  };
+
+static struct db_trans oakley_trans_psk2openssl[] = {
+	{ KEY_IKE, AD(ot1024des3sha_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024des3sha_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024des3md5_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024des3md5_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024des3sha_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024des3sha_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024des3md5_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024des3md5_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024des3sha_ds_dss), have_dss_key },
+	{ KEY_IKE, AD(ot1024des3sha_ds_rsa), have_rsa_key },
+	{ KEY_IKE, AD(ot1024des3md5_ds_rsa), have_rsa_key },
+	{ KEY_IKE, AD(otpsk1024des3sha), NULL },
+	{ KEY_IKE, AD(otpsk1024des3md5), NULL },
+	{ KEY_IKE, AD(ot1536des3sha_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536des3sha_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536des3md5_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536des3md5_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536des3sha_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536des3sha_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536des3md5_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536des3md5_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536des3sha_ds_dss), have_dss_key },
+	{ KEY_IKE, AD(ot1536des3sha_ds_rsa), have_rsa_key },
+	{ KEY_IKE, AD(ot1536des3md5_ds_rsa), have_rsa_key },
+	{ KEY_IKE, AD(otpsk1536des3md5), NULL },
+	{ KEY_IKE, AD(otpsk1536des3sha), NULL },
+/* DES */
+	{ KEY_IKE, AD(ot1024dessha_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024dessha_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024desmd5_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024desmd5_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024dessha_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024dessha_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024desmd5_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1024desmd5_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1024dessha_ds_dss), have_dss_key },
+	{ KEY_IKE, AD(ot1024dessha_ds_rsa), have_rsa_key },
+	{ KEY_IKE, AD(ot1024desmd5_ds_rsa), have_rsa_key },
+	{ KEY_IKE, AD(otpsk1024dessha), NULL },
+	{ KEY_IKE, AD(otpsk1024desmd5), NULL },
+
+	{ KEY_IKE, AD(ot1536dessha_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536dessha_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536desmd5_rpk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536desmd5_rpk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536dessha_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536dessha_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536desmd5_pk_elgamal), have_elgamal_keypair },
+	{ KEY_IKE, AD(ot1536desmd5_pk_rsa), have_rsa_keypair },
+	{ KEY_IKE, AD(ot1536dessha_ds_dss), have_dss_key },
+	{ KEY_IKE, AD(ot1536dessha_ds_rsa), have_rsa_key },
+	{ KEY_IKE, AD(ot1536desmd5_ds_rsa), have_rsa_key },
+	{ KEY_IKE, AD(otpsk1536desmd5), NULL },
+	{ KEY_IKE, AD(otpsk1536dessha), NULL },
+  };
+#endif /* #ifdef OPENSSL */
+
+
 /* In this table, either PSK or RSA sig is accepted.
  * The order matters, but I don't know what would be best.
  */
@@ -151,6 +638,18 @@
 	{ KEY_IKE, AD(otpsk1536des3md5) },
 	{ KEY_IKE, AD(otrsasig1536des3sha) },
 	{ KEY_IKE, AD(otpsk1536des3sha) },
+/* DES */
+#ifdef TEST_INDECENT_PROPOSAL
+	{ KEY_IKE, AD(otpsk1024destiger) },
+#endif
+	{ KEY_IKE, AD(otrsasig1024dessha) },
+	{ KEY_IKE, AD(otpsk1024dessha) },
+	{ KEY_IKE, AD(otrsasig1024desmd5) },
+	{ KEY_IKE, AD(otpsk1024desmd5) },
+	{ KEY_IKE, AD(otrsasig1536desmd5) },
+	{ KEY_IKE, AD(otpsk1536desmd5) },
+	{ KEY_IKE, AD(otrsasig1536dessha) },
+	{ KEY_IKE, AD(otpsk1536dessha) },
     };
 
 /* array of proposals to be conjoined (can only be one for Oakley) */
@@ -164,6 +663,17 @@
 static struct db_prop oakley_pc_pskrsasig[] =
     { { PROTO_ISAKMP, AD(oakley_trans_pskrsasig) } };
 
+#ifdef OPENSSL
+static struct db_prop oakley_pc_psk2[] =
+    { { PROTO_ISAKMP, AD(oakley_trans_psk2) } };
+
+static struct db_prop oakley_pc_openssl[] =
+    { { PROTO_ISAKMP, AD(oakley_trans_openssl) } };
+
+static struct db_prop oakley_pc_psk2openssl[] =
+    { { PROTO_ISAKMP, AD(oakley_trans_psk2openssl) } };
+#endif
+
 /* array of proposal conjuncts (can only be one) */
 
 static struct db_prop_conj oakley_props_psk[] = { { AD(oakley_pc_psk) } };
@@ -172,6 +682,14 @@
 
 static struct db_prop_conj oakley_props_pskrsasig[] = { { AD(oakley_pc_pskrsasig) } };
 
+#ifdef OPENSSL
+static struct db_prop_conj oakley_props_psk2[] = { { AD(oakley_pc_psk2) } };
+
+static struct db_prop_conj oakley_props_openssl[] = { { AD(oakley_pc_openssl) } };
+
+static struct db_prop_conj oakley_props_psk2openssl[] = { { AD(oakley_pc_psk2openssl) } };
+#endif
+
 /* the sadb entry, subscripted by POLICY_PSK and POLICY_RSASIG bits */
 struct db_sa oakley_sadb[] = {
     { AD_NULL },	/* none */
@@ -180,6 +698,16 @@
     { AD(oakley_props_pskrsasig) },	/* POLICY_PSK + POLICY_RSASIG */
     };
 
+#ifdef OPENSSL
+/* the sadb entry, subscripted by POLICY_PSK and POLICY_OPENSSL bits */
+struct db_sa oakley_sadb2[] = {
+    { NULL, 0 },	/* none */
+    { AD(oakley_props_psk2) },	/* POLICY_PSK */
+    { AD(oakley_props_openssl) },	/* POLICY_OPENSSL */
+    { AD(oakley_props_psk2openssl) },	/* POLICY_PSK + POLICY_OPENSSL */
+    };
+#endif
+
 /**************** IPsec (quick mode) SA database ****************/
 
 /* arrays of attributes for transforms */
@@ -203,12 +731,22 @@
 /* arrays of transforms, each in in preference order */
 
 static struct db_trans espa_trans[] = {
+#ifndef OPENSSL
     { ESP_3DES, AD(espmd5_attr) },
     { ESP_3DES, AD(espsha1_attr) },
+    { ESP_DES, AD(espmd5_attr) },
+    { ESP_DES, AD(espsha1_attr) },
+#else
+    { ESP_3DES, AD(espmd5_attr), NULL },
+    { ESP_3DES, AD(espsha1_attr), NULL },
+    { ESP_DES, AD(espmd5_attr), NULL },
+    { ESP_DES, AD(espsha1_attr), NULL },
+#endif
     };
 
 static struct db_trans esp_trans[] = {
     { ESP_3DES, AD_NULL },
+    { ESP_DES, AD_NULL },
     };
 
 #ifdef SUPPORT_ESP_NULL
@@ -219,8 +757,13 @@
 #endif /* SUPPORT_ESP_NULL */
 
 static struct db_trans ah_trans[] = {
+#ifndef OPENSSL
     { AH_MD5, AD(ah_HMAC_MD5_attr) },
     { AH_SHA, AD(ah_HMAC_SHA1_attr) },
+#else
+    { AH_MD5, AD(ah_HMAC_MD5_attr), NULL },
+    { AH_SHA, AD(ah_HMAC_SHA1_attr), NULL },
+#endif
     };
 
 static struct db_trans ipcomp_trans[] = {
@@ -327,12 +870,11 @@
 
 /* output an attribute (within an SA) */
 static bool
-out_attr(
-	int type,
-	unsigned long val,
-	struct_desc *attr_desc,
-	enum_names **attr_val_descs UNUSED,
-	pb_stream *pbs)
+out_attr(int type
+, unsigned long val
+, struct_desc *attr_desc
+, enum_names **attr_val_descs UNUSED
+, pb_stream *pbs)
 {
     struct isakmp_attribute attr;
 
@@ -366,8 +908,8 @@
 	enum_names *d = attr_val_descs[type];
 
 	if (d != NULL)
-	    DBG_log("    [%lu is %s]",
-		val, enum_show(d, val)));
+	    DBG_log("    [%lu is %s]"
+		, val, enum_show(d, val)));
     return TRUE;
 }
 
@@ -375,19 +917,17 @@
  * This has the side-effect of allocating SPIs for us.
  */
 bool
-out_sa(
-    pb_stream *outs,
-    struct db_sa *sadb,
-    struct state *st,
-    bool oakley_mode,
-    u_int8_t np)
+out_sa(pb_stream *outs
+, struct db_sa *sadb
+, struct state *st
+, bool oakley_mode
+, u_int8_t np)
 {
     pb_stream sa_pbs;
     int pcn;
-    bool
-	ah_spi_generated = FALSE,
-	esp_spi_generated = FALSE,
-	ipcomp_cpi_generated = FALSE;
+    bool ah_spi_generated = FALSE
+	, esp_spi_generated = FALSE
+	, ipcomp_cpi_generated = FALSE;
 
     /* SA header out */
     {
@@ -437,7 +977,19 @@
 	    proposal.isap_spisize = oakley_mode ? 0
 		: p->protoid == PROTO_IPCOMP ? IPCOMP_CPI_SIZE
 		: IPSEC_DOI_SPI_SIZE;
+
+#ifndef OPENSSL
 	    proposal.isap_notrans = p->trans_cnt;
+#else
+	    proposal.isap_notrans = 0;
+	    for(tn = 0; tn < p->trans_cnt; tn++) {
+	      struct db_trans *t = &(p->trans[tn]);
+	      if (t->offer == NULL)
+	        proposal.isap_notrans++;
+	      else if ((t->offer(st))) /* only offer a propsal if we can carry it out */
+	        proposal.isap_notrans++;
+	    }
+#endif
 	    if (!out_struct(&proposal, &isakmp_proposal_desc, &sa_pbs, &proposal_pbs))
 		return FALSE;
 
@@ -536,6 +1088,14 @@
 
 		trans.isat_np = (tn == p->trans_cnt - 1)
 		    ? ISAKMP_NEXT_NONE : ISAKMP_NEXT_T;
+#ifdef OPENSSL
+		if ((t->offer != NULL) && ((t->offer)(st) == FALSE)) {
+		  DBG(DBG_PARSING,
+		  DBG_log("Skipping unavailable cipher: %d", tn);
+		  );
+		  continue; /* skip unavailable cipher */
+		}
+#endif
 		trans.isat_transnum = tn;
 		trans.isat_transid = t->transid;
 		if (!out_struct(&trans, trans_desc, &proposal_pbs, &trans_pbs))
